



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>自己调用NTDLL函数</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">自己调用NTDLL函数</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-26 13:50:53 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h3><strong>一、概述</strong></h3>
<p>在DLL初始化的时候有时不能调用其它系统DLL的函数，以免导致问题，但有时候又必须要调用怎么办？一种办法就是自己直接调用NTDLL接口，这样肯定没有问题。</p>
<p>下面我写个自己调用Registry的封装类，用来代替原本系统注册表API。</p>
<h3><strong>二、申明NTDLL导出函数</strong></h3>
<p>在自己工程中需要调用NTDLL导出函数，可以通GetProcessAddr来获取函数地址再调用，也可以通过导入库的方式（这种需要ntdll.lib文件，在DDK中有），我这里采用第二种方式。</p>
<h4>函数和类型声明：</h4>
<p>NTDllDecl.h</p>
<div>
<pre class="prettyprint linenums">#pragma once<br />
#include &lt;windows.h&gt;<br />
#include &lt;winternl.h&gt;

namespace NT {<br />
    extern "C" {

// macro definition<br />
#ifndef NTSTATUS<br />
#define NTSTATUS    LONG<br />
#endif

#ifndef NTAPI<br />
#define NTAPI        __stdcall<br />
#endif

#ifndef NTSYSAPI<br />
#define NTSYSAPI    __declspec(dllimport)<br />
#endif

#ifndef STATUS_BUFFER_OVERFLOW<br />
#define STATUS_BUFFER_OVERFLOW           ((NTSTATUS)0x80000005L)<br />
#endif

typedef enum _KEY_INFORMATION_CLASS {<br />
    KeyBasicInformation,<br />
    KeyNodeInformation,<br />
    KeyFullInformation,<br />
    KeyNameInformation,<br />
    KeyCachedInformation,<br />
    KeyFlagsInformation,<br />
    KeyVirtualizationInformation,<br />
    KeyHandleTagsInformation,<br />
    MaxKeyInfoClass  // MaxKeyInfoClass should always be the last enum<br />
} KEY_INFORMATION_CLASS;

typedef enum _KEY_VALUE_INFORMATION_CLASS {<br />
    KeyValueBasicInformation,<br />
    KeyValueFullInformation,<br />
    KeyValuePartialInformation,<br />
    KeyValueFullInformationAlign64,<br />
    KeyValuePartialInformationAlign64,<br />
    MaxKeyValueInfoClass  // MaxKeyValueInfoClass should always be the last enum<br />
} KEY_VALUE_INFORMATION_CLASS;

typedef struct _KEY_BASIC_INFORMATION {<br />
    LARGE_INTEGER LastWriteTime;<br />
    ULONG   TitleIndex;<br />
    ULONG   NameLength;<br />
    WCHAR   Name[1];            // Variable length string<br />
} KEY_BASIC_INFORMATION, *PKEY_BASIC_INFORMATION;

typedef struct _KEY_NODE_INFORMATION {<br />
    LARGE_INTEGER LastWriteTime;<br />
    ULONG   TitleIndex;<br />
    ULONG   ClassOffset;<br />
    ULONG   ClassLength;<br />
    ULONG   NameLength;<br />
    WCHAR   Name[1];            // Variable length string<br />
//          Class[1];           // Variable length string not declared<br />
} KEY_NODE_INFORMATION, *PKEY_NODE_INFORMATION;

typedef struct _KEY_FULL_INFORMATION {<br />
    LARGE_INTEGER LastWriteTime;<br />
    ULONG   TitleIndex;<br />
    ULONG   ClassOffset;<br />
    ULONG   ClassLength;<br />
    ULONG   SubKeys;<br />
    ULONG   MaxNameLen;<br />
    ULONG   MaxClassLen;<br />
    ULONG   Values;<br />
    ULONG   MaxValueNameLen;<br />
    ULONG   MaxValueDataLen;<br />
    WCHAR   Class[1];           // Variable length<br />
} KEY_FULL_INFORMATION, *PKEY_FULL_INFORMATION;

typedef struct _KEY_VALUE_BASIC_INFORMATION {<br />
    ULONG   TitleIndex;<br />
    ULONG   Type;<br />
    ULONG   NameLength;<br />
    WCHAR   Name[1];            // Variable size<br />
} KEY_VALUE_BASIC_INFORMATION, *PKEY_VALUE_BASIC_INFORMATION;

typedef struct _KEY_VALUE_PARTIAL_INFORMATION {<br />
    ULONG   TitleIndex;<br />
    ULONG   Type;<br />
    ULONG   DataLength;<br />
    UCHAR   Data[1];            // Variable size<br />
} KEY_VALUE_PARTIAL_INFORMATION, *PKEY_VALUE_PARTIAL_INFORMATION;

// Registry<br />
NTSYSAPI<br />
NTSTATUS<br />
NTAPI<br />
ZwCreateKey(<br />
    OUT PHANDLE KeyHandle,<br />
    IN ACCESS_MASK DesiredAccess,<br />
    IN POBJECT_ATTRIBUTES ObjectAttributes,<br />
    IN ULONG TitleIndex,<br />
    IN PUNICODE_STRING Class,<br />
    IN ULONG CreateOptions,<br />
    OUT PULONG Disposition<br />
    );

NTSYSAPI<br />
NTSTATUS<br />
NTAPI<br />
ZwOpenKey(<br />
    OUT PHANDLE KeyHandle,<br />
    IN ACCESS_MASK DesiredAccess,<br />
    IN POBJECT_ATTRIBUTES ObjectAttributes<br />
    );

NTSYSAPI<br />
NTSTATUS<br />
NTAPI<br />
ZwQueryKey(<br />
    IN HANDLE KeyHandle,<br />
    IN KEY_INFORMATION_CLASS KeyInformationClass,<br />
    OUT PVOID KeyInformation,<br />
    IN ULONG KeyInformationLength,<br />
    OUT PULONG ResultLength<br />
    );

NTSYSAPI<br />
NTSTATUS<br />
NTAPI<br />
ZwSetValueKey(<br />
    IN HANDLE KeyHandle,<br />
    IN PUNICODE_STRING ValueName,<br />
    IN ULONG TitleIndex,<br />
    IN ULONG Type,<br />
    IN PVOID Data,<br />
    IN ULONG DataSize<br />
    );

NTSYSAPI<br />
NTSTATUS<br />
NTAPI<br />
ZwQueryValueKey(<br />
    IN HANDLE KeyHandle,<br />
    IN PUNICODE_STRING ValueName,<br />
    IN KEY_VALUE_INFORMATION_CLASS KeyValueInformationClass,<br />
    OUT PVOID KeyValueInformation,<br />
    IN ULONG KeyValueInformationLength,<br />
    OUT PULONG ResultLength<br />
    );

NTSYSAPI<br />
NTSTATUS<br />
NTAPI<br />
ZwEnumerateKey(<br />
    IN HANDLE KeyHandle,<br />
    IN ULONG Index,<br />
    IN KEY_INFORMATION_CLASS KeyInformationClass,<br />
    OUT PVOID KeyInformation,<br />
    IN ULONG KeyInformationLength,<br />
    OUT PULONG ResultLength<br />
    );

NTSYSAPI<br />
NTSTATUS<br />
NTAPI<br />
ZwClose(<br />
    IN HANDLE Handle<br />
    );

NTSYSAPI<br />
NTSTATUS<br />
NTAPI<br />
RtlFormatCurrentUserKeyPath(<br />
    OUT PUNICODE_STRING RegistryPath<br />
    );

    }<br />
};</pre>
</div>
<h3><strong>三、封装自己注册表函数</strong></h3>
<p>自己定义一个类用来封装注册表函数，我这里只封装了几个需要用的注册表函数（参考ReatOS和Windows代码），其余的可以后续再添加。</p>
<h4>注册封装类声明：</h4>
<p>NTRegistry.h</p>
<div>
<pre class="prettyprint linenums">//********************************************************************<br />
//    文件名:        NTRegistry.h<br />
//    文件描述:      Ntdll导出注册表函数定义头文件<br />
//    作者:<br />
//    版本:          1.0<br />
//<br />
//    修改历史:<br />
//    备注:<br />
//*********************************************************************<br />
#pragma once

#ifndef STATIC<br />
#define STATIC        static<br />
#endif

#ifndef NTSTATUS<br />
#define NTSTATUS    LONG<br />
#endif

class NTRegistry<br />
{<br />
public:

    STATIC LONG RegCreateKey(<br />
                HKEY hKey,<br />
                LPCWSTR lpSubKey,<br />
                DWORD Reserved,<br />
                LPWSTR lpClass,<br />
                DWORD dwOptions,<br />
                REGSAM samDesired,<br />
                LPSECURITY_ATTRIBUTES lpSecurityAttributes,<br />
                PHKEY phkResult,<br />
                LPDWORD lpdwDisposition);

    STATIC LONG RegOpenKey(<br />
                HKEY hKey,<br />
                LPCWSTR lpSubKey,<br />
                DWORD ulOptions,<br />
                REGSAM samDesired,<br />
                PHKEY phkResult);

    STATIC LONG RegQueryInfoKey(<br />
                HKEY hKey,<br />
                LPWSTR lpClass,<br />
                LPDWORD lpcbClass,<br />
                LPDWORD lpReserved,<br />
                LPDWORD lpcSubKeys,<br />
                LPDWORD lpcbMaxSubKeyLen,<br />
                LPDWORD lpcbMaxClassLen,<br />
                LPDWORD lpcValues,<br />
                LPDWORD lpcbMaxValueNameLen,<br />
                LPDWORD lpcbMaxValueLen,<br />
                LPDWORD lpcbSecurityDescriptor,<br />
                PFILETIME lpftLastWriteTime<br />
                );

    STATIC LONG RegSetValue(<br />
                HKEY hKey,<br />
                LPCWSTR lpValueName,<br />
                DWORD Reserved,<br />
                DWORD dwType,<br />
                CONST BYTE* lpData,<br />
                DWORD cbData);

    STATIC LONG RegQueryValue(<br />
                HKEY hKey,<br />
                LPCWSTR lpValueName,<br />
                LPDWORD lpReserved,<br />
                LPDWORD lpType,<br />
                LPBYTE lpData,<br />
                LPDWORD lpcbData<br />
                );

    STATIC LONG RegEnumKey(<br />
                HKEY hKey,<br />
                DWORD dwIndex,<br />
                LPWSTR lpName,<br />
                LPDWORD lpcbName,<br />
                LPDWORD lpReserved,<br />
                LPWSTR lpClass,<br />
                LPDWORD lpcbClass,<br />
                PFILETIME lpftLastWriteTime);

    STATIC LONG RegCloseKey(HKEY hKey);

private:

    STATIC NTSTATUS OpenCurrentUser(<br />
                IN ACCESS_MASK DesiredAccess,<br />
                OUT PHANDLE KeyHandle);

    STATIC NTSTATUS OpenLocalMachineKey(<br />
                OUT PHANDLE KeyHandle);

    STATIC NTSTATUS OpenCurrentConfigKey (PHANDLE KeyHandle);

    STATIC NTSTATUS OpenUsersKey(PHANDLE KeyHandle);

    STATIC NTSTATUS OpenClassesRootKey(PHANDLE KeyHandle);

    STATIC NTSTATUS MapDefaultKey(<br />
                OUT PHANDLE RealKey,<br />
                IN HKEY Key);<br />
};</pre>
</div>
<h4>注册封装类定义：</h4>
<p>NTRegistry.cpp</p>
<div>
<pre class="prettyprint linenums">#include "StdAfx.h"<br />
#include "NTRegistry.h"<br />
#include "NTDllDecl.h"

#define ARGUMENT_PRESENT( arg )                                            \<br />
    ((( PVOID ) arg ) != (( PVOID ) NULL ))

#define DEFAULT_KEY_NAME_SIZE                    128<br />
#define DEFAULT_CLASS_SIZE                        128<br />
#define DEFAULT_VALUE_SIZE                        128

#define REG_MAX_NAME_SIZE                        256<br />
#define REG_MAX_DATA_SIZE                        2048

#ifndef STATUS_SUCCESS<br />
#define STATUS_SUCCESS                          ((NTSTATUS)0x00000000L)<br />
#endif

#define RTL_CONSTANT_STRING(__SOURCE_STRING__)                            \<br />
{                                                                        \<br />
    sizeof(__SOURCE_STRING__) - sizeof((__SOURCE_STRING__)[0]),            \<br />
    sizeof(__SOURCE_STRING__),                                            \<br />
    (__SOURCE_STRING__)                                                    \<br />
}

#define IsPredefKey(HKey)                                               \<br />
    (((ULONG_PTR)(HKey) &amp; 0xF0000000) == 0x80000000)

#define ClosePredefKey(Handle)                                          \<br />
    if ((ULONG_PTR)Handle &amp; 0x1) {                                      \<br />
        NT::ZwClose(Handle);                                            \<br />
    }

NTSTATUS<br />
NTRegistry::OpenCurrentUser(<br />
    IN ACCESS_MASK DesiredAccess,<br />
    OUT PHANDLE KeyHandle)<br />
{<br />
    OBJECT_ATTRIBUTES ObjectAttributes;<br />
    UNICODE_STRING KeyPath;<br />
    NTSTATUS Status;

    /* Get the user key */<br />
    Status = NT::RtlFormatCurrentUserKeyPath(&amp;KeyPath);<br />
    if (NT_SUCCESS(Status))<br />
    {<br />
        /* Initialize the attributes and open it */<br />
        InitializeObjectAttributes(&amp;ObjectAttributes,<br />
                                   &amp;KeyPath,<br />
                                   OBJ_CASE_INSENSITIVE,<br />
                                   NULL,<br />
                                   NULL);<br />
        Status = NT::ZwOpenKey(KeyHandle, DesiredAccess, &amp;ObjectAttributes);

        /* Free the path and return success if it worked */<br />
        RtlFreeUnicodeString(&amp;KeyPath);<br />
    }

    return Status;<br />
}

NTSTATUS<br />
NTRegistry::OpenLocalMachineKey(<br />
    OUT PHANDLE KeyHandle)<br />
{<br />
    OBJECT_ATTRIBUTES Attributes;<br />
    UNICODE_STRING KeyName = RTL_CONSTANT_STRING(L"\\Registry\\Machine");<br />
    NTSTATUS Status;

    InitializeObjectAttributes(<br />
        &amp;Attributes,<br />
        &amp;KeyName,<br />
        OBJ_CASE_INSENSITIVE,<br />
        NULL,<br />
        NULL);<br />
    Status = NT::ZwOpenKey(KeyHandle, MAXIMUM_ALLOWED, &amp;Attributes);

    return Status;<br />
}

NTSTATUS<br />
NTRegistry::OpenClassesRootKey(PHANDLE KeyHandle)<br />
{<br />
    OBJECT_ATTRIBUTES Attributes;<br />
    UNICODE_STRING KeyName = RTL_CONSTANT_STRING(L"\\Registry\\Machine\\Software\\CLASSES");

    InitializeObjectAttributes(<br />
        &amp;Attributes,<br />
        &amp;KeyName,<br />
        OBJ_CASE_INSENSITIVE,<br />
        NULL,<br />
        NULL);

    return NT::ZwOpenKey(KeyHandle,<br />
                     MAXIMUM_ALLOWED,<br />
                     &amp;Attributes);<br />
}

NTSTATUS<br />
NTRegistry::OpenUsersKey(PHANDLE KeyHandle)<br />
{<br />
    OBJECT_ATTRIBUTES Attributes;<br />
    UNICODE_STRING KeyName = RTL_CONSTANT_STRING(L"\\Registry\\User");

    InitializeObjectAttributes(&amp;Attributes,<br />
                               &amp;KeyName,<br />
                               OBJ_CASE_INSENSITIVE,<br />
                               NULL,<br />
                               NULL);<br />
    return NT::ZwOpenKey(KeyHandle,<br />
                     MAXIMUM_ALLOWED,<br />
                     &amp;Attributes);<br />
}

NTSTATUS<br />
NTRegistry::OpenCurrentConfigKey (PHANDLE KeyHandle)<br />
{<br />
    OBJECT_ATTRIBUTES Attributes;<br />
    UNICODE_STRING KeyName =<br />
        RTL_CONSTANT_STRING(L"\\Registry\\Machine\\System\\CurrentControlSet\\Hardware Profiles\\Current");

    InitializeObjectAttributes(&amp;Attributes,<br />
                               &amp;KeyName,<br />
                               OBJ_CASE_INSENSITIVE,<br />
                               NULL,<br />
                               NULL);<br />
    return NT::ZwOpenKey(KeyHandle,<br />
                     MAXIMUM_ALLOWED,<br />
                     &amp;Attributes);<br />
}

NTSTATUS<br />
NTRegistry::MapDefaultKey(<br />
    OUT PHANDLE RealKey,<br />
    IN HKEY Key)<br />
{<br />
    NTSTATUS Status;<br />
    if (!IsPredefKey(Key))<br />
    {<br />
        *RealKey = (HANDLE)((ULONG_PTR)Key &amp; ~0x1);<br />
        return STATUS_SUCCESS;<br />
    }

    switch ((LONG)Key)<br />
    {<br />
    case HKEY_CURRENT_USER:<br />
        {<br />
            Status = OpenCurrentUser(MAXIMUM_ALLOWED, RealKey);<br />
        }<br />
        break;

    case HKEY_LOCAL_MACHINE:<br />
        {<br />
            Status = OpenLocalMachineKey(RealKey);<br />
        }<br />
        break;

    case HKEY_CLASSES_ROOT:<br />
        {<br />
            Status = OpenClassesRootKey(RealKey);<br />
        }<br />
        break;

    case HKEY_USERS:<br />
        {<br />
            Status = OpenUsersKey(RealKey);<br />
        }<br />
        break;

    case HKEY_CURRENT_CONFIG:<br />
        {<br />
            Status = OpenCurrentConfigKey(RealKey);<br />
        }<br />
        break;

    default:<br />
        Status = STATUS_INVALID_PARAMETER;<br />
        break;<br />
    }

    return Status;<br />
}

LONG<br />
NTRegistry::RegCreateKey(<br />
    HKEY hKey,<br />
    LPCWSTR lpSubKey,<br />
    DWORD Reserved,<br />
    LPWSTR lpClass,<br />
    DWORD dwOptions,<br />
    REGSAM samDesired,<br />
    LPSECURITY_ATTRIBUTES lpSecurityAttributes,<br />
    PHKEY phkResult,<br />
    LPDWORD lpdwDisposition)<br />
{<br />
    UNICODE_STRING SubKeyString;<br />
    UNICODE_STRING ClassString;<br />
    OBJECT_ATTRIBUTES ObjectAttributes;<br />
    HANDLE ParentKey = NULL;<br />
    NTSTATUS Status;

    if (lpSecurityAttributes &amp;&amp; lpSecurityAttributes-&gt;nLength != sizeof(SECURITY_ATTRIBUTES))<br />
    {<br />
        return ERROR_INVALID_USER_BUFFER;<br />
    }

    /* get the real parent key */<br />
    Status = MapDefaultKey(&amp;ParentKey,<br />
                           hKey);<br />
    if (!NT_SUCCESS(Status))<br />
    {<br />
        return RtlNtStatusToDosError(Status);<br />
    }

    if (!phkResult)<br />
    {<br />
        return ERROR_INVALID_PARAMETER;<br />
    }

    RtlInitUnicodeString(&amp;ClassString, lpClass);<br />
    RtlInitUnicodeString(&amp;SubKeyString, lpSubKey);

    InitializeObjectAttributes(<br />
        &amp;ObjectAttributes,<br />
        &amp;SubKeyString,<br />
        OBJ_CASE_INSENSITIVE,<br />
        (HANDLE)ParentKey,<br />
        lpSecurityAttributes ? (PSECURITY_DESCRIPTOR)lpSecurityAttributes-&gt;lpSecurityDescriptor : NULL);

    Status = NT::ZwCreateKey(<br />
        (PHANDLE)phkResult,<br />
        samDesired,<br />
        &amp;ObjectAttributes,<br />
        0,<br />
        (lpClass == NULL) ? NULL : &amp;ClassString,                    /* optional*/<br />
        dwOptions,<br />
        lpdwDisposition<br />
        );         

    ClosePredefKey(ParentKey);    

    return RtlNtStatusToDosError( Status );<br />
}

LONG NTRegistry::RegOpenKey(<br />
    HKEY hKey,<br />
    LPCWSTR lpSubKey,<br />
    DWORD ulOptions,<br />
    REGSAM samDesired,<br />
    PHKEY phkResult)<br />
{<br />
    OBJECT_ATTRIBUTES ObjectAttributes;<br />
    UNICODE_STRING SubKeyString;<br />
    HANDLE KeyHandle;<br />
    NTSTATUS Status;

    if (!phkResult)<br />
    {<br />
        return ERROR_INVALID_PARAMETER;<br />
    }

    Status = MapDefaultKey(&amp;KeyHandle, hKey);<br />
    if (!NT_SUCCESS(Status))<br />
    {<br />
        return RtlNtStatusToDosError(Status);<br />
    }

    if (lpSubKey != NULL)<br />
        RtlInitUnicodeString(&amp;SubKeyString, (LPWSTR)lpSubKey);<br />
    else<br />
        RtlInitUnicodeString(&amp;SubKeyString, (LPWSTR)L"");

    InitializeObjectAttributes(<br />
        &amp;ObjectAttributes,<br />
        &amp;SubKeyString,<br />
        OBJ_CASE_INSENSITIVE,<br />
        KeyHandle,<br />
        NULL<br />
        );

    Status = NT::ZwOpenKey(<br />
        (PHANDLE)phkResult,<br />
        samDesired,<br />
        &amp;ObjectAttributes<br />
        );

    ClosePredefKey(KeyHandle);

    return RtlNtStatusToDosError( Status );<br />
}

LONG NTRegistry::RegQueryInfoKey(<br />
    HKEY hKey,<br />
    LPWSTR lpClass,<br />
    LPDWORD lpcbClass,<br />
    LPDWORD lpReserved,<br />
    LPDWORD lpcSubKeys,<br />
    LPDWORD lpcbMaxSubKeyLen,<br />
    LPDWORD lpcbMaxClassLen,<br />
    LPDWORD lpcValues,<br />
    LPDWORD lpcbMaxValueNameLen,<br />
    LPDWORD lpcbMaxValueLen,<br />
    LPDWORD lpcbSecurityDescriptor,<br />
    PFILETIME lpftLastWriteTime<br />
    )<br />
{<br />
    NT::KEY_FULL_INFORMATION FullInfoBuffer;<br />
    NT::PKEY_FULL_INFORMATION FullInfo;<br />
    ULONG FullInfoSize;<br />
    ULONG ClassLength = 0;<br />
    HANDLE KeyHandle;<br />
    NTSTATUS Status;<br />
    ULONG Length;<br />
    LONG ErrorCode = ERROR_SUCCESS;

    if ((lpClass) &amp;&amp; (!lpcbClass))<br />
    {<br />
        return ERROR_INVALID_PARAMETER;<br />
    }

    Status = MapDefaultKey(&amp;KeyHandle,<br />
                           hKey);<br />
    if (!NT_SUCCESS(Status))<br />
    {<br />
        return RtlNtStatusToDosError(Status);<br />
    }

    if (lpClass != NULL)<br />
    {<br />
        if (*lpcbClass &gt; 0)<br />
        {<br />
            ClassLength = min(*lpcbClass - 1, REG_MAX_NAME_SIZE) * sizeof(WCHAR);<br />
        }<br />
        else<br />
        {<br />
            ClassLength = 0;<br />
        }

        FullInfoSize = sizeof(NT::KEY_FULL_INFORMATION) + ((ClassLength + 3) &amp; ~3);<br />
        FullInfo = (NT::PKEY_FULL_INFORMATION)HeapAlloc(GetProcessHeap(),<br />
                             0,<br />
                             FullInfoSize);<br />
        if (FullInfo == NULL)<br />
        {<br />
            ErrorCode = ERROR_OUTOFMEMORY;<br />
            goto Cleanup;<br />
        }

        FullInfo-&gt;ClassLength = ClassLength;<br />
    }<br />
    else<br />
    {<br />
        FullInfoSize = sizeof(NT::KEY_FULL_INFORMATION);<br />
        FullInfo = &amp;FullInfoBuffer;<br />
        FullInfo-&gt;ClassLength = 0;<br />
    }<br />
    FullInfo-&gt;ClassOffset = FIELD_OFFSET(NT::KEY_FULL_INFORMATION, Class);

    Status = NT::ZwQueryKey(KeyHandle,<br />
                        NT::KeyFullInformation,<br />
                        FullInfo,<br />
                        FullInfoSize,<br />
                        &amp;Length);<br />
    if (!NT_SUCCESS(Status))<br />
    {<br />
        if (lpClass != NULL)<br />
        {<br />
            HeapFree(GetProcessHeap(),<br />
                        0,<br />
                        FullInfo);<br />
        }

        ErrorCode = RtlNtStatusToDosError(Status);<br />
        goto Cleanup;<br />
    }

    if (lpcSubKeys != NULL)<br />
    {<br />
        *lpcSubKeys = FullInfo-&gt;SubKeys;<br />
    }

    if (lpcbMaxSubKeyLen != NULL)<br />
    {<br />
        *lpcbMaxSubKeyLen = FullInfo-&gt;MaxNameLen / sizeof(WCHAR) + 1;<br />
    }

    if (lpcbMaxClassLen != NULL)<br />
    {<br />
        *lpcbMaxClassLen = FullInfo-&gt;MaxClassLen / sizeof(WCHAR) + 1;<br />
    }

    if (lpcValues != NULL)<br />
    {<br />
        *lpcValues = FullInfo-&gt;Values;<br />
    }

    if (lpcbMaxValueNameLen != NULL)<br />
    {<br />
        *lpcbMaxValueNameLen = FullInfo-&gt;MaxValueNameLen / sizeof(WCHAR) + 1;<br />
    }

    if (lpcbMaxValueLen != NULL)<br />
    {<br />
        *lpcbMaxValueLen = FullInfo-&gt;MaxValueDataLen;<br />
    }

    if (lpftLastWriteTime != NULL)<br />
    {<br />
        lpftLastWriteTime-&gt;dwLowDateTime = FullInfo-&gt;LastWriteTime.u.LowPart;<br />
        lpftLastWriteTime-&gt;dwHighDateTime = FullInfo-&gt;LastWriteTime.u.HighPart;<br />
    }

    if (lpClass != NULL)<br />
    {<br />
        if (FullInfo-&gt;ClassLength &gt; ClassLength)<br />
        {<br />
            ErrorCode = ERROR_BUFFER_OVERFLOW;<br />
        }<br />
        else<br />
        {<br />
            RtlCopyMemory(lpClass,<br />
                            FullInfo-&gt;Class,<br />
                            FullInfo-&gt;ClassLength);<br />
            *lpcbClass = FullInfo-&gt;ClassLength / sizeof(WCHAR);<br />
            lpClass[*lpcbClass] = 0;<br />
        }

        HeapFree(GetProcessHeap(),<br />
                    0,<br />
                    FullInfo);<br />
    }

Cleanup:

    ClosePredefKey(KeyHandle);

    return ErrorCode;<br />
}

LONG NTRegistry::RegSetValue(<br />
    HKEY hKey,<br />
    LPCWSTR lpValueName,<br />
    DWORD Reserved,<br />
    DWORD dwType,<br />
    CONST BYTE* lpData,<br />
    DWORD cbData)<br />
{<br />
    UNICODE_STRING ValueName;<br />
    PUNICODE_STRING pValueName;<br />
    HANDLE KeyHandle;<br />
    NTSTATUS Status;

    Status = MapDefaultKey(&amp;KeyHandle,<br />
                           hKey);<br />
    if (!NT_SUCCESS(Status))<br />
    {<br />
        return RtlNtStatusToDosError(Status);<br />
    }

    RtlInitUnicodeString(&amp;ValueName, lpValueName);<br />
    pValueName = &amp;ValueName;

    if ((dwType == REG_SZ) || (dwType == REG_EXPAND_SZ) || (dwType == REG_MULTI_SZ) &amp;&amp; (cbData != 0))<br />
    {<br />
        PWSTR pwsData = (PWSTR)lpData;

        if((pwsData[cbData / sizeof(WCHAR) - 1] != L'\0') &amp;&amp;<br />
            (pwsData[cbData / sizeof(WCHAR)] == L'\0'))<br />
        {<br />
            /* Increment length if last character is not zero and next is zero */<br />
            cbData += sizeof(WCHAR);<br />
        }<br />
    }

    Status = NT::ZwSetValueKey(<br />
        hKey,<br />
        &amp;ValueName,<br />
        0,<br />
        dwType,<br />
        (PVOID)lpData,<br />
        cbData);

    ClosePredefKey(KeyHandle);

    return RtlNtStatusToDosError( Status );<br />
}

LONG NTRegistry::RegQueryValue(<br />
    HKEY hKey,<br />
    LPCWSTR lpValueName,<br />
    LPDWORD lpReserved,<br />
    LPDWORD lpType,<br />
    LPBYTE lpData,<br />
    LPDWORD lpcbData<br />
    )<br />
{<br />
    NTSTATUS Status;<br />
    UNICODE_STRING ValueName;<br />
    ULONG    BufferLength;<br />
    NT::KEY_VALUE_INFORMATION_CLASS KeyValueInformationClass;<br />
    PVOID    KeyValueInformation;<br />
    ULONG    ResultLength;<br />
    HANDLE    KeyHandle;<br />
    BYTE    PrivateKeyValueInformation[ sizeof( NT::KEY_VALUE_PARTIAL_INFORMATION ) +<br />
                                        DEFAULT_VALUE_SIZE ];

    //<br />
    // Validate dependency between lpData and lpcbData parameters.<br />
    //

    if( ARGUMENT_PRESENT( lpReserved ) ||<br />
        (ARGUMENT_PRESENT( lpData ) &amp;&amp; ( ! ARGUMENT_PRESENT( lpcbData )))) {<br />
        return ERROR_INVALID_PARAMETER;<br />
    }

    Status = MapDefaultKey(&amp;KeyHandle,<br />
                           hKey);<br />
    if (!NT_SUCCESS(Status))<br />
    {<br />
        return RtlNtStatusToDosError(Status);<br />
    }

    //<br />
    // Convert the value name to a counted Unicode string.<br />
    //

    RtlInitUnicodeString( &amp;ValueName, lpValueName );

    //<br />
    //  First we assume that the information we want will fit on<br />
    //  PrivateKeyValueInformattion<br />
    //

    KeyValueInformationClass = ( ARGUMENT_PRESENT( lpcbData ))?<br />
                               NT::KeyValuePartialInformation :<br />
                               NT::KeyValueBasicInformation;

    KeyValueInformation = PrivateKeyValueInformation;<br />
    BufferLength = sizeof( PrivateKeyValueInformation );    

    Status = NT::ZwQueryValueKey(<br />
                KeyHandle,<br />
                &amp;ValueName,<br />
                KeyValueInformationClass,<br />
                KeyValueInformation,<br />
                BufferLength,<br />
                &amp;ResultLength);

    if( ( Status == STATUS_BUFFER_OVERFLOW ) &amp;&amp;<br />
        ( !ARGUMENT_PRESENT( lpData ) ) )<br />
    {

        Status = STATUS_SUCCESS;<br />
    }

    if( Status == STATUS_BUFFER_OVERFLOW )<br />
    {<br />
        //<br />
        //  The buffer defined in the stack wasn't big enough to hold<br />
        //  the Value information.<br />
        //  If the caller's buffer is big enough to hold the value data<br />
        //  then allocate a new buffer, and call the NT API again.<br />
        //<br />
        if( ( ( KeyValueInformationClass == NT::KeyValuePartialInformation ) &amp;&amp;<br />
              ( ARGUMENT_PRESENT( lpData ) ) &amp;&amp;<br />
              ( *lpcbData &gt;= (( NT::PKEY_VALUE_PARTIAL_INFORMATION )KeyValueInformation )-&gt;DataLength)) )<br />
        {<br />
            BufferLength = ResultLength;

            KeyValueInformation = HeapAlloc( GetProcessHeap( ), 0, BufferLength);<br />
            //<br />
            // If the memory allocation fails, return a Registry error.<br />
            //

            if( ! KeyValueInformation )<br />
            {<br />
                return ERROR_OUTOFMEMORY;<br />
            }

            //<br />
            // Query for the necessary information about the supplied value.<br />
            //

            Status = NT::ZwQueryValueKey(<br />
                            KeyHandle,<br />
                            &amp;ValueName,<br />
                            KeyValueInformationClass,<br />
                            KeyValueInformation,<br />
                            BufferLength,<br />
                            &amp;ResultLength<br />
                            );<br />
        }<br />
    }

    if( NT_SUCCESS( Status ) &amp;&amp;<br />
        ARGUMENT_PRESENT( lpData ) )<br />
    {<br />
        //<br />
        //  If requested, copy the value data<br />
        //<br />
        if( *lpcbData &gt;= (( NT::PKEY_VALUE_PARTIAL_INFORMATION )<br />
                            KeyValueInformation )-&gt;DataLength )<br />
        {

            RtlMoveMemory( lpData, (( NT::PKEY_VALUE_PARTIAL_INFORMATION )KeyValueInformation )-&gt;Data,<br />
                           (( NT::PKEY_VALUE_PARTIAL_INFORMATION )KeyValueInformation )-&gt;DataLength);

        }<br />
        else<br />
        {<br />
            Status = STATUS_BUFFER_OVERFLOW;<br />
        }<br />
    }

    //<br />
    // Certain information is returned on success or in the case of<br />
    // NtQueryValueKey returning STATUS_BUFFER_OVERFLOW.  This information<br />
    // is always available because we always pass the minimum size required for<br />
    // the NtQueryValueKey API.<br />
    //

    if( NT_SUCCESS( Status ) ||<br />
        ( Status == STATUS_BUFFER_OVERFLOW ) ) {

        if( KeyValueInformationClass == NT::KeyValueBasicInformation ) {

            //<br />
            // If requested, return the value type.<br />
            //

            if( ARGUMENT_PRESENT( lpType )) {

                *lpType = (( NT::PKEY_VALUE_BASIC_INFORMATION )<br />
                            KeyValueInformation )-&gt;Type;<br />
            }

        } else {

            //<br />
            // If requested, return the value type.<br />
            //

            if( ARGUMENT_PRESENT( lpType )) {

                *lpType = (( NT::PKEY_VALUE_PARTIAL_INFORMATION )<br />
                            KeyValueInformation )-&gt;Type;<br />
            }

            //<br />
            // Return the value data size<br />
            //<br />
            *lpcbData = (( NT::PKEY_VALUE_PARTIAL_INFORMATION )<br />
                            KeyValueInformation )-&gt;DataLength;<br />
        }<br />
    }

    //<br />
    // Transmit all of the data back to the client.<br />
    //

    if( ARGUMENT_PRESENT( lpcbData ) ) {<br />
        if( NT_SUCCESS( Status ) &amp;&amp;<br />
            ARGUMENT_PRESENT( lpData ) ) {<br />
            *lpcbData = (( NT::PKEY_VALUE_PARTIAL_INFORMATION )<br />
                        KeyValueInformation )-&gt;DataLength;<br />
        } else {<br />
            //<br />
            // The API failed, so make sure that no data is transmitted back<br />
            // to the client. This ensures that the client stub will not<br />
            // attempt to unmarshall data that doesn't exist.<br />
            //

            *lpcbData = 0;<br />
        }<br />
    }

    //<br />
    //  If memory was allocated, then free it<br />
    //<br />
    if( KeyValueInformation != PrivateKeyValueInformation ) {

        HeapFree( GetProcessHeap( ), 0, KeyValueInformation );<br />
    }

    return RtlNtStatusToDosError( Status );<br />
}

LONG NTRegistry::RegEnumKey(<br />
    HKEY hKey,<br />
    DWORD dwIndex,<br />
    LPWSTR lpName,<br />
    LPDWORD lpcName,<br />
    LPDWORD lpReserved,<br />
    LPWSTR lpClass,<br />
    LPDWORD lpcClass,<br />
    PFILETIME lpftLastWriteTime)<br />
{<br />
    NTSTATUS Status;<br />
    NT::KEY_INFORMATION_CLASS  KeyInformationClass;<br />
    UNICODE_STRING NameString;<br />
    UNICODE_STRING ClassString;<br />
    PVOID  KeyInformation;<br />
    ULONG  BufferLength;<br />
    ULONG  ResultLength;<br />
    HANDLE KeyHandle;<br />
    BYTE   PrivateKeyInformation[ sizeof( NT::KEY_NODE_INFORMATION ) +<br />
                                        DEFAULT_KEY_NAME_SIZE +<br />
                                        DEFAULT_CLASS_SIZE ];

    if( !ARGUMENT_PRESENT( lpName ) ||<br />
        (ARGUMENT_PRESENT( lpClass ) &amp;&amp; ( ! ARGUMENT_PRESENT( lpcClass )))) {<br />
        return ERROR_INVALID_PARAMETER;<br />
    }

    //<br />
    // Use the supplied name string buffer as the buffer in a counted<br />
    // Unicode string.<br />
    //<br />
    NameString.Length           = 0;<br />
    if ((*lpcName &lt;&lt; 1) &gt; 0xFFFE) {<br />
        NameString.MaximumLength    = ( USHORT ) 0xFFFE;<br />
    } else {<br />
        NameString.MaximumLength    = ( USHORT )( *lpcName &lt;&lt; 1 );<br />
    }<br />
    NameString.Buffer           = lpName;

    //<br />
    // If supplied use the supplied name string buffer as the buffer in a<br />
    // counted Unicode string.<br />
    //<br />
    if (ARGUMENT_PRESENT( lpClass ))<br />
        RtlInitUnicodeString(&amp;ClassString, (LPWSTR)lpClass);<br />
    else<br />
        RtlInitUnicodeString(&amp;ClassString, (LPWSTR)L"");    

    //<br />
    //  First we assume that the information we want will fit on<br />
    //  PrivateKeyValueInformattion<br />
    //

    KeyInformationClass = (ARGUMENT_PRESENT( lpClass )) ?  NT::KeyNodeInformation : NT::KeyBasicInformation;

    KeyInformation = PrivateKeyInformation;<br />
    BufferLength = sizeof( PrivateKeyInformation );

    Status = MapDefaultKey(&amp;KeyHandle,<br />
                           hKey);<br />
    if (!NT_SUCCESS(Status))<br />
    {<br />
        return RtlNtStatusToDosError(Status);<br />
    }

    Status = NT::ZwEnumerateKey(<br />
        KeyHandle,<br />
        dwIndex,<br />
        KeyInformationClass,<br />
        KeyInformation,<br />
        BufferLength,<br />
        &amp;ResultLength);

    if( Status == STATUS_BUFFER_OVERFLOW ) {<br />
        //<br />
        //  The buffer defined in the stack wasn't big enough to hold<br />
        //  the Key information.<br />
        //  If the caller's buffer are big enough to hold the key name<br />
        //  and key class, then allocate a new buffer, and call the<br />
        //  NT API again.<br />
        //<br />
        if( ( ( KeyInformationClass == NT::KeyBasicInformation ) &amp;&amp;<br />
              ( (ULONG)(NameString.MaximumLength) &gt;= (( NT::PKEY_BASIC_INFORMATION )KeyInformation )-&gt;NameLength + sizeof(UNICODE_NULL)) ) ||<br />
            ( ( KeyInformationClass == NT::KeyNodeInformation ) &amp;&amp;<br />
              ( (ULONG)(NameString.MaximumLength) &gt;= (( NT::PKEY_NODE_INFORMATION )KeyInformation )-&gt;NameLength + sizeof(UNICODE_NULL)) &amp;&amp;<br />
              ( ARGUMENT_PRESENT( lpClass )) &amp;&amp;<br />
              ( (ULONG)(ClassString.MaximumLength) &gt;= (( NT::PKEY_NODE_INFORMATION )KeyInformation )-&gt;ClassLength + sizeof(UNICODE_NULL))<br />
            ) )<br />
        {<br />
            BufferLength = ResultLength;

            KeyInformation = HeapAlloc( GetProcessHeap( ), 0, BufferLength);<br />
            //<br />
            // If the memory allocation fails, return a Registry error.<br />
            //

            if( ! KeyInformation ) {<br />
                return ERROR_OUTOFMEMORY;<br />
            }

            //<br />
            // Query for the necessary information about the supplied key.<br />
            // This may or may not include the class depending on lpClass-&gt;Buffer<br />
            // as determined above.<br />
            //

            {<br />
                Status = NT::ZwEnumerateKey(<br />
                            KeyHandle, dwIndex,<br />
                            KeyInformationClass,<br />
                            KeyInformation,<br />
                            BufferLength,<br />
                            &amp;ResultLength);<br />
            }

        }<br />
    }

    if( NT_SUCCESS( Status ) )<br />
    {

        if( KeyInformationClass == NT::KeyBasicInformation )<br />
        {<br />
            //<br />
            // Return the name length and the name of the key.<br />
            // Note that the NUL byte is included so that RPC copies the<br />
            // correct number of bytes. It is decremented on the client<br />
            // side.<br />
            //

            if( (ULONG)(NameString.MaximumLength) &gt;=<br />
                 (( NT::PKEY_BASIC_INFORMATION )KeyInformation )-&gt;NameLength + sizeof( UNICODE_NULL ) )<br />
            {

                NameString.Length = ( USHORT )(( NT::PKEY_BASIC_INFORMATION )KeyInformation )-&gt;NameLength;

                RtlMoveMemory( NameString.Buffer,<br />
                    (( NT::PKEY_BASIC_INFORMATION )KeyInformation )-&gt;Name,<br />
                    NameString.Length);

                //<br />
                // NUL terminate the value name.<br />
                //

                NameString.Buffer[ NameString.Length &gt;&gt; 1 ] = UNICODE_NULL;<br />
                if( ARGUMENT_PRESENT( lpcName )) {

                    *lpcName = NameString.Length &gt;&gt; 1;<br />
                }

            } else {

                Status = STATUS_BUFFER_OVERFLOW;<br />
            }

            //<br />
            // If requested, return the last write time.<br />
            //

            if( ARGUMENT_PRESENT( lpftLastWriteTime )) {

                *lpftLastWriteTime = *( PFILETIME )&amp;(( NT::PKEY_BASIC_INFORMATION ) KeyInformation )-&gt;LastWriteTime;<br />
            }

        } else {<br />
            //<br />
            // Return the name length and the name of the key.<br />
            // Note that the NUL byte is included so that RPC copies the<br />
            // correct number of bytes. It is decremented on the client<br />
            // side.<br />
            //

            if( ( (ULONG)(NameString.MaximumLength) &gt;=<br />
                  (( NT::PKEY_NODE_INFORMATION )<br />
                   KeyInformation )-&gt;NameLength + sizeof( UNICODE_NULL ) ) &amp;&amp;<br />
                ( (ULONG)(ClassString.MaximumLength) &gt;=<br />
                  (( NT::PKEY_NODE_INFORMATION )<br />
                   KeyInformation )-&gt;ClassLength + sizeof( UNICODE_NULL) )<br />
              ) {<br />
                //<br />
                //  Copy the key name<br />
                //<br />
                NameString.Length = ( USHORT )<br />
                                 (( NT::PKEY_NODE_INFORMATION )<br />
                                 KeyInformation )-&gt;NameLength;

                RtlMoveMemory( NameString.Buffer,<br />
                               (( NT::PKEY_NODE_INFORMATION )KeyInformation )-&gt;Name,<br />
                               NameString.Length<br />
                             );

                //<br />
                // NUL terminate the key name.<br />
                //

                NameString.Buffer[ NameString.Length &gt;&gt; 1 ] = UNICODE_NULL;<br />
                if( ARGUMENT_PRESENT( lpcName )) {

                    *lpcName = NameString.Length &gt;&gt; 1;<br />
                }

                //<br />
                //  Copy the key class<br />
                //

                ClassString.Length = (USHORT)<br />
                    ((( NT::PKEY_NODE_INFORMATION ) KeyInformation )-&gt;ClassLength );

                RtlMoveMemory(<br />
                    ClassString.Buffer,<br />
                    ( PBYTE ) KeyInformation<br />
                    + (( NT::PKEY_NODE_INFORMATION ) KeyInformation )-&gt;ClassOffset,<br />
                    ClassString.Length<br />
                    );

                //<br />
                // NUL terminate the class.<br />
                //

                ClassString.Buffer[ ClassString.Length &gt;&gt; 1 ] = UNICODE_NULL;<br />
                if( ARGUMENT_PRESENT( lpcClass )) {

                    *lpcClass = ClassString.Length &gt;&gt; 1;<br />
                }

            } else {<br />
                Status = STATUS_BUFFER_OVERFLOW;<br />
            }

            //<br />
            // If requested, return the last write time.<br />
            //

            if( ARGUMENT_PRESENT( lpftLastWriteTime )) {

                *lpftLastWriteTime<br />
                = *( PFILETIME )<br />
                &amp;(( NT::PKEY_NODE_INFORMATION ) KeyInformation )<br />
                -&gt;LastWriteTime;<br />
            }<br />
        }<br />
    }

    if( KeyInformation != PrivateKeyInformation ) {<br />
        //<br />
        // Free the buffer allocated.<br />
        //

        HeapFree( GetProcessHeap( ), 0, KeyInformation );<br />
    }

    return RtlNtStatusToDosError( Status );<br />
}

LONG NTRegistry::RegCloseKey(HKEY hKey)<br />
{<br />
    NTSTATUS Status;<br />
    /* don't close null handle or a pseudo handle */<br />
    if ((!hKey) || (((ULONG_PTR)hKey &amp; 0xF0000000) == 0x80000000))<br />
    {<br />
        return ERROR_INVALID_HANDLE;<br />
    }

    Status = NT::ZwClose( hKey );

    return RtlNtStatusToDosError( Status );<br />
}</pre>
</div>
<h3><strong>四、项目设置</strong></h3>
<p>为了使用NTDLL导出函数，我们这里还需要用到ntdll.lib，需要在工程属性中添加导入ntdll.lib，只需要把ntdll.lib从DDK中拷贝出来放到你自己第三方库位置。</p>
<h3><strong>五、测试程序</strong></h3>
<p>测试了个获取Adobe安装目录的程序</p>
<p>NtFunctionTest.cpp</p>
<div>
<pre class="prettyprint linenums">#include "stdafx.h"<br />
#include &lt;gtest/gtest.h&gt;<br />
#include &lt;string&gt;<br />
#include &lt;NT/NtRegistry.h&gt;

TEST(GsKernelTest, tRegistryKey)<br />
{

    HKEY hKey = NULL;<br />
    LONG RetVal    = NTRegistry::RegOpenKey(<br />
                    HKEY_LOCAL_MACHINE,<br />
                    L"SOFTWARE\\Adobe\\Acrobat Reader",<br />
                    REG_OPTION_NON_VOLATILE,<br />
                    KEY_READ,<br />
                    &amp;hKey);<br />
    ASSERT_TRUE(RetVal==ERROR_SUCCESS);<br />
    if ( ERROR_SUCCESS != RetVal )<br />
    {<br />
        return;<br />
    }

    DWORD cSubKeys = 0;<br />
    RetVal = NTRegistry::RegQueryInfoKey(hKey, NULL, NULL, NULL, &amp;cSubKeys, NULL, NULL, NULL, NULL, NULL, NULL, NULL );<br />
    ASSERT_TRUE(RetVal==ERROR_SUCCESS);<br />
    if ( ERROR_SUCCESS != RetVal )<br />
    {<br />
        NTRegistry::RegCloseKey(hKey);<br />
        return;<br />
    }

    TCHAR szKeyName[MAX_PATH];<br />
    for ( DWORD i=0; i &lt; cSubKeys; ++i )<br />
    {<br />
        DWORD dwKeyNameLength = sizeof(szKeyName)/sizeof(szKeyName[0]);<br />
        RetVal = NTRegistry::RegEnumKey( hKey, i, szKeyName, &amp;dwKeyNameLength, NULL, NULL, NULL,NULL);<br />
        if ( ERROR_SUCCESS != RetVal )<br />
        {<br />
            continue;<br />
        }

        double fVersion = _tstof(szKeyName);<br />
        DWORD dwVesion = (DWORD)(fVersion*10);

        if ( dwVesion &gt; 120 || dwVesion &lt; 60  )<br />
        {<br />
            continue;<br />
        }        

        /// 拷贝文件<br />
        TCHAR szAdobePath[MAX_PATH];<br />
        _tcscat_s(szKeyName,_countof(szKeyName), TEXT("\\InstallPath"));<br />
        HKEY hChildKey = NULL;<br />
        RetVal = NTRegistry::RegOpenKey(hKey, szKeyName, 0, KEY_READ, &amp;hChildKey);<br />
        if ( ERROR_SUCCESS != RetVal )<br />
        {<br />
            continue;<br />
        }

        DWORD cKey = sizeof(szAdobePath);<br />
        RetVal = NTRegistry::RegQueryValue(hChildKey, NULL, 0, NULL, (LPBYTE)szAdobePath, &amp;cKey );<br />
        if ( ERROR_SUCCESS == RetVal )<br />
        {<br />
            wcout &lt;&lt; L"InstallPath: " &lt;&lt; szAdobePath &lt;&lt; endl;<br />
        }

        NTRegistry::RegCloseKey(hChildKey);

    }

    NTRegistry::RegCloseKey(hKey);<br />
}</pre>
</div>
<p>我的测试代码都是放到测试工程中的，采用的是gTest框架。</p>
<p>不采用导入ntdll.lib库方式的我后面再补充，只要通过GetProcessAddr获取函数地址就可以了。</p>
<div>
<pre class="prettyprint linenums"><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/78090/201509/78090-20150925161956490-804272031.png">  看书、学习、写代码</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/g8e45rz9.html">CSS3 制作一个边框向周围散开的按钮效果</a>
		</li>
						<li><a href="https://www.batexi.com/a/rql10de9.html">Nginx 日志中记录cookie</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8er56mq.html">CSS好看的按钮</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qyorom8.html">InnoDB源码分析--事务日志（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93l0w09.html">osgconv 将多个模型合成一个模型</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvmnwxq.html">ACE - Reactor模式源码剖析及具体实现（大量源码慎入）</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96wke4q.html">TCP&sol;IP 协议：链路层概述</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jyg7w9.html">httpclient提交json参数</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wjvp3q.html">Linux发行分支时间轴</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdlnlk8.html">asp&period;net导出excel示例代码</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z14rz19.html">php 安全处理方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdekg7x9.html">第二百五十二天 how can I 坚持</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7m0zz1q.html">Codeigniter开发技巧：连接多个数据库（可实现DB读写分离）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1dw2x9.html">&period;offset&lpar;&rpar;与&period;position&lpar;&rpar;区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k13z639.html">javascript操作HTML元素</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7z250g9.html">王者荣耀&lowbar;KEY</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpgy6zq.html">sessionStorage、localStorage 存储及如何存储数组与对象</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kn7359.html">MySQL配置文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlloj1eq.html">牛客练习赛38 D 题 出题人的手环 （离散化&plus;树状数组求逆序对&plus;前缀和）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m24260q.html">linux&lpar;centos&rpar; 添加系统环境变量</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8z1rx5d9.html">Unix 哲学</a>
			</li>
						<li><a href="https://www.batexi.com/a/96o7kj39.html">maven 部署到tomcat 的 resource问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/93xdlrg9.html">&lbrack;iOS微博项目 - 2&period;4&rsqb; - 重新安排app启动步骤</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4ym1g3q.html">c&plus;&plus;，windows中的字符问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/90vj55n8.html">css控制图片自适应大小</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2wmzmlq.html">Visual Studio无法添加断点</a>
			</li>
						<li><a href="https://www.batexi.com/a/qn12ojg8.html">input标签写CSS时需要注意的几点（先收藏）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e15v6x9.html">（2）html文本格式化 解说</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxno76e8.html">TMsgThread&comma; TCommThread  -- 在delphi线程中实现消息循环</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gm4oxe9.html">dmalloc 原文 翻译整理</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
